
function asks()
	if dat.askw > 50 then
		sntp.sync({"ntp1.stratum1.ru", "ntp4.stratum2.ru", "ntp3.stratum2.ru"},
			function()
				tm = rtctime.epoch2cal(rtctime.get()+3*60*60)
				print('Got NTP at '..tm.hour..':'..tm.min)
				dat.askw = 1
			end,
			function()
			   print('NTP failed!')
		end)
	end
	if dat.askw == 1 or dat.askw == 25 then
		coroutine.resume(coroutine.create(function() dofile('askweather.lua')end))
	elseif dat.askn and (dat.askw == 2 or dat.askw == 26) then
		dofile('asknarod.lua')
	else
		if dat.askw%2 == 0 then
			if dat.ds18b20 then
				dofile('askds18b20.lua')
			end
		else
			if dat.broker then dofile('pubnow.lua') end
		end  
	end
	dat.askw = dat.askw + 1
end

function printdata(data, sep)
	local izzr
	local prt = {}
	local function copytb(tb, ind)
		for i = 1, 8 do
			tb[i] = dig[ind][i]
		end 
	end
	for i = 1, 4 do
		izzr = string.sub(data, i, i)
		prt[i] = {}
		copytb(prt[i], izzr)
	end
	izzr = nil
	if sep == ":" then 
		if not dat.dotp then
			prt[2][4] = prt[2][4] + 1
			prt[2][6] = prt[2][6] + 1
			dat.dotp = true
		end
		dat.dot1 = prt[2][4]
		dat.dot2 = prt[2][6]
	end
	
	if sep == '.' then 
		prt[3][8] = prt[3][8] + 1 
	end
	max7219.write(prt)
	prt, copytb = nil, nil
end

function gettime()
	tm = rtctime.epoch2cal(rtctime.get()+3*60*60)
	local sh = tostring(tm.hour)
	local sm = tostring(tm.min)
	if #sh == 1 then sh = '0'.. sh end
	if #sm == 1 then sm = '0'.. sm end
	dat.lasttime = sh..sm
	if dat.mnow == dat.lasttime then
		if dat.dotp then
			dat.dotp = false
			dat.dot1 = bit.clear(dat.dot1, 0)
			dat.dot2 = bit.clear(dat.dot2, 0)
		else
			dat.dotp = true
			dat.dot1 = bit.set(dat.dot1, 0)
			dat.dot2 = bit.set(dat.dot2, 0)
		end
		max7219.sb(2,4,dat.dot1)
		max7219.sb(2,6,dat.dot2)
		return
	else
		dat.mnow = dat.lasttime
		printdata(dat.lasttime, ':')
	end
end

function maketemp(home)
	local t
	if home then t = dat.ds18b20 
	elseif dat.askn then t = dat.narod
	else t = dat.asktemp end
	
	dat.tempernow = tonumber(t) or -85
	local first = string.sub(t, 1, string.find(t,'%.')-1) or t
	local sep = string.find(t,"%.") or 0
	local second = sep ==  0 and '0' or string.sub(t, sep+1, sep+1)
	if string.sub(first,1,1) ~= '-' and not home then 
		first = '+'..first 
	else
		first = 'H'..first
	end
	first = first..second
	if #first < 4 then all = 'z'..all end
	dat.mnow = first
	t, first, sep, second = nil, nil, nil ,nil
	printdata(dat.mnow, '.')
end

tik = tmr.create()
tik:alarm(1000, 1, gettime)

tmrwth = tmr.create()
tmrwth:alarm(dat.int * 1000, 1, function()
	if tm.hour > 6 and tm.hour < 22 and not dat.intens then
		dat.intens = true
		max7219.setIntensity(11)
	elseif tm.hour >= 22 and dat.intens then
		dat.intens = false
		max7219.setIntensity(1)
	end
	print(node.heap())
	tik:stop()
	local tmranm = 2000
	
	if dat.anm then
		dat.call = maketemp
		if dat.askw%6 == 0 then
			tmranm = 3000
			dofile('moveupcall.lua')
		elseif dat.askw%3 == 0 then
			tmranm = 3000
			dofile('moveleftcall.lua')
		else
			dat.call = nil
			maketemp()
		end
	else
		maketemp()
	end
	tmr.create():alarm(tmranm, 0, function(t)
		t = nil
		dofile('prtForecast.lua')
	end)
end)